/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_TPOCORINFU                                                                                       */
/* Tabela : TPOCORINFU                                                                                                               */
/*                                                                                                                                                        \*/
/* Criao:                                                                                                                                          */
/* 14/12/2004 - Rafael dos Santos Lopes                           			                        */
/*                                                                                                                                                        */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TPOCORINFU
BEFORE INSERT OR UPDATE OR DELETE
ON TPOCORINFU FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTPOI := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.NMTPOCORINFU,0) <> NVL(:NEW.NMTPOCORINFU,0))   THEN
         :NEW.DTULTATUTPOI := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TPOCORINFU', '', 'CDTPOCORINFU='||:OLD.CDTPOCORINFU||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TPOCORINFU MODIFY DTULTATUTPOI DEFAULT SYSDATE
/

