/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_IMPR                                                     */
/* Tabela : IMPRESSORA                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 13/12/2006 - Nicole Campos                                                 */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_IMPR'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_IMPR
GO

CREATE TRIGGER DTULTATU_IMPR
ON IMPRESSORA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
       			      (SELECT 'IMPRESSORA', NULL, 'CDIMPRESSORA=' + CDIMPRESSORA + ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE IMPRESSORA
      SET DTULTATUIMPR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(IMPRESSORA.CDIMPRESSORA,0) = ISNULL(INSERTED.CDIMPRESSORA,0));
   END;
END;
GO

UPDATE IMPRESSORA SET DTULTATUIMPR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUIMPR IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUIMPR' and
            type = 'D')
   ALTER TABLE IMPRESSORA DROP CONSTRAINT DEFAULT_DTULTATUIMPR
GO

ALTER TABLE IMPRESSORA ADD CONSTRAINT DEFAULT_DTULTATUIMPR
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUIMPR
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_IMPR','4.11.194';
GO

